﻿/*!
    *
    * Wijmo Library 5.20251.34
    * https://developer.mescius.com/wijmo
    *
    * Copyright(c) MESCIUS inc. All rights reserved.
    *
    * Licensed under the End-User License Agreement For MESCIUS Wijmo Software.
    * us.sales@mescius.com
    * https://developer.mescius.com/wijmo/licensing
    *
    */

import * as ɵngcc0 from '@angular/core';

const _c0 = ["*"];
var WjFlexGrid_1,WjFlexGridColumn_1,WjFlexGridColumnGroup_1,WjFlexGridCellTemplate_1,__decorate=this&&this.__decorate||function(e,t,i,o){var r,l=arguments.length,n=l<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(n=(l<3?r(n):l>3?r(t,i,n):r(t,i))||n);return l>3&&n&&Object.defineProperty(t,i,n),n},__param=this&&this.__param||function(e,t){return function(i,o){t(i,o,e)}};import{Component,NgModule,ElementRef,Injector,Directive,ViewContainerRef,TemplateRef,Optional,forwardRef,Input,Inject,ChangeDetectorRef,SkipSelf}from"@angular/core";import{CommonModule}from"@angular/common";import{NG_VALUE_ACCESSOR}from"@angular/forms";import{WjDirectiveBehavior,WjValueAccessorFactory}from"@grapecity/wijmo.angular2.directivebase";import{DirectiveCellFactoryBase}from"@grapecity/wijmo.interop.grid";import*as wjcCore from"@grapecity/wijmo";import*as wjcGrid from"@grapecity/wijmo.grid";import*as wjcInteropGrid from"@grapecity/wijmo.interop.grid";export var CellTemplateType=wjcInteropGrid.GridCellTemplateType;var wjFlexGridMeta={selector:"wj-flex-grid",standalone: false,template:"<div><ng-content></ng-content></div>",inputs:["wjModelProperty","isDisabled","tabOrder","newRowAtTop","allowAddNew","allowDelete","allowDragging","allowMerging","allowResizing","allowSorting","allowPinning","autoScroll","autoRowHeights","autoSizeMode","autoGenerateColumns","autoSearch","caseSensitiveSearch","quickAutoSize","bigCheckboxes","childItemsPath","groupHeaderFormat","headersVisibility","showSelectedHeaders","showMarquee","showPlaceholders","itemFormatter","isReadOnly","imeEnabled","mergeManager","selectionMode","showGroups","showSort","showDropDown","showAlternatingRows","showErrors","alternatingRowStep","itemValidator","validateEdits","treeIndent","itemsSource","autoClipboard","expandSelectionOnCopyPaste","frozenCells","frozenRows","frozenColumns","cloneFrozenCells","deferResizing","sortRowIndex","editColumnIndex","stickyHeaders","preserveSelectedState","preserveOutlineState","preserveWhiteSpace","keyActionTab","keyActionEnter","rowHeaderPath","virtualizationThreshold","anchorCursor","lazyRender","refreshOnEdit","copyHeaders","columnGroups","commitEmptyEdits","headersFocusability","ariaLabel","skipMerged","pasteEmptyCells","groupSummaryPosition","sortOrder","noDataOverlayContent"],outputs:["initialized","gotFocusNg: gotFocus","lostFocusNg: lostFocus","refreshingNg: refreshing","refreshedNg: refreshed","invalidInputNg: invalidInput","beginningEditNg: beginningEdit","cellEditEndedNg: cellEditEnded","cellEditEndingNg: cellEditEnding","prepareCellForEditNg: prepareCellForEdit","formatItemNg: formatItem","resizingColumnNg: resizingColumn","resizedColumnNg: resizedColumn","autoSizingColumnNg: autoSizingColumn","autoSizedColumnNg: autoSizedColumn","draggingColumnNg: draggingColumn","draggingColumnOverNg: draggingColumnOver","draggedColumnNg: draggedColumn","sortingColumnNg: sortingColumn","sortedColumnNg: sortedColumn","pinningColumnNg: pinningColumn","pinnedColumnNg: pinnedColumn","resizingRowNg: resizingRow","resizedRowNg: resizedRow","autoSizingRowNg: autoSizingRow","autoSizedRowNg: autoSizedRow","draggingRowNg: draggingRow","draggingRowOverNg: draggingRowOver","draggedRowNg: draggedRow","deletingRowNg: deletingRow","deletedRowNg: deletedRow","loadingRowsNg: loadingRows","loadedRowsNg: loadedRows","rowEditStartingNg: rowEditStarting","rowEditStartedNg: rowEditStarted","rowEditEndingNg: rowEditEnding","rowEditEndedNg: rowEditEnded","rowAddedNg: rowAdded","groupCollapsedChangingNg: groupCollapsedChanging","groupCollapsedChangedNg: groupCollapsedChanged","columnGroupCollapsedChangingNg: columnGroupCollapsedChanging","columnGroupCollapsedChangedNg: columnGroupCollapsedChanged","itemsSourceChangingNg: itemsSourceChanging","itemsSourceChangedNg: itemsSourceChanged","selectionChangingNg: selectionChanging","selectionChangedNg: selectionChanged","scrollPositionChangedNg: scrollPositionChanged","updatingViewNg: updatingView","updatedViewNg: updatedView","updatingLayoutNg: updatingLayout","updatedLayoutNg: updatedLayout","pastingNg: pasting","pastedNg: pasted","pastingCellNg: pastingCell","pastedCellNg: pastedCell","copyingNg: copying","copiedNg: copied"],providers:[{provide:NG_VALUE_ACCESSOR,useFactory:WjValueAccessorFactory,multi:!0,deps:["WjComponent"]}]};export{wjFlexGridMeta};let WjFlexGrid=WjFlexGrid_1=class WjFlexGrid extends wjcGrid.FlexGrid{constructor(e,t,i,o){super(WjDirectiveBehavior.getHostElement(e,t));this.cdRef=o;this.isInitialized=!1;this._wjBehaviour=WjDirectiveBehavior.attach(this,e,t,i);new DirectiveCellFactory(this,o);this.deferUpdate(()=>{if(this.rows.defaultSize<10){let e=this.hostElement,t=getComputedStyle(e),i=getComputedStyle(document.body),o=2*parseInt(t.fontSize&&wjcCore.contains(document.body,e)?t.fontSize:i.fontSize);this.rows.defaultSize=o;this.columns.defaultSize=4*o;this.columnHeaders.rows.defaultSize=o;this.rowHeaders.columns.defaultSize=Math.round(1.25*o)}});this.created()}created(){}ngOnInit(){this._wjBehaviour.ngOnInit()}ngAfterViewInit(){this._wjBehaviour.ngAfterViewInit()}ngOnDestroy(){this._wjBehaviour.ngOnDestroy()}addEventListener(e,t,i,o=!1){let r=WjDirectiveBehavior,l=r.getZone(this);l&&r.outsideZoneEvents[t]?l.runOutsideAngular(()=>{super.addEventListener(e,t,i,o)}):super.addEventListener(e,t,i,o)}startEditing(e=!0,t,i,o,r){this._edtFocus=null;let l=super.startEditing(e,t,i,o,r);l&&(this._edtFocus=o||null==o);return l}onCellEditEnding(e){this._edtFocus=null;return super.onCellEditEnding(e)}};
WjFlexGrid.ɵfac = function WjFlexGrid_Factory(t) { return new (t || WjFlexGrid)(ɵngcc0.ɵɵdirectiveInject(ElementRef), ɵngcc0.ɵɵdirectiveInject(Injector), ɵngcc0.ɵɵdirectiveInject("WjComponent", 12), ɵngcc0.ɵɵdirectiveInject(ChangeDetectorRef)); };
WjFlexGrid.ɵcmp = /*@__PURE__*/ ɵngcc0.ɵɵdefineComponent({ type: WjFlexGrid, standalone: false, selectors: [["wj-flex-grid"]], inputs: { wjModelProperty: "wjModelProperty", isDisabled: "isDisabled", tabOrder: "tabOrder", newRowAtTop: "newRowAtTop", allowAddNew: "allowAddNew", allowDelete: "allowDelete", allowDragging: "allowDragging", allowMerging: "allowMerging", allowResizing: "allowResizing", allowSorting: "allowSorting", allowPinning: "allowPinning", autoScroll: "autoScroll", autoRowHeights: "autoRowHeights", autoSizeMode: "autoSizeMode", autoGenerateColumns: "autoGenerateColumns", autoSearch: "autoSearch", caseSensitiveSearch: "caseSensitiveSearch", quickAutoSize: "quickAutoSize", bigCheckboxes: "bigCheckboxes", childItemsPath: "childItemsPath", groupHeaderFormat: "groupHeaderFormat", headersVisibility: "headersVisibility", showSelectedHeaders: "showSelectedHeaders", showMarquee: "showMarquee", showPlaceholders: "showPlaceholders", itemFormatter: "itemFormatter", isReadOnly: "isReadOnly", imeEnabled: "imeEnabled", mergeManager: "mergeManager", selectionMode: "selectionMode", showGroups: "showGroups", showSort: "showSort", showDropDown: "showDropDown", showAlternatingRows: "showAlternatingRows", showErrors: "showErrors", alternatingRowStep: "alternatingRowStep", itemValidator: "itemValidator", validateEdits: "validateEdits", treeIndent: "treeIndent", itemsSource: "itemsSource", autoClipboard: "autoClipboard", expandSelectionOnCopyPaste: "expandSelectionOnCopyPaste", frozenCells: "frozenCells", frozenRows: "frozenRows", frozenColumns: "frozenColumns", cloneFrozenCells: "cloneFrozenCells", deferResizing: "deferResizing", sortRowIndex: "sortRowIndex", editColumnIndex: "editColumnIndex", stickyHeaders: "stickyHeaders", preserveSelectedState: "preserveSelectedState", preserveOutlineState: "preserveOutlineState", preserveWhiteSpace: "preserveWhiteSpace", keyActionTab: "keyActionTab", keyActionEnter: "keyActionEnter", rowHeaderPath: "rowHeaderPath", virtualizationThreshold: "virtualizationThreshold", anchorCursor: "anchorCursor", lazyRender: "lazyRender", refreshOnEdit: "refreshOnEdit", copyHeaders: "copyHeaders", columnGroups: "columnGroups", commitEmptyEdits: "commitEmptyEdits", headersFocusability: "headersFocusability", ariaLabel: "ariaLabel", skipMerged: "skipMerged", pasteEmptyCells: "pasteEmptyCells", groupSummaryPosition: "groupSummaryPosition", sortOrder: "sortOrder", noDataOverlayContent: "noDataOverlayContent" }, outputs: { initialized: "initialized", gotFocusNg: "gotFocus", lostFocusNg: "lostFocus", refreshingNg: "refreshing", refreshedNg: "refreshed", invalidInputNg: "invalidInput", beginningEditNg: "beginningEdit", cellEditEndedNg: "cellEditEnded", cellEditEndingNg: "cellEditEnding", prepareCellForEditNg: "prepareCellForEdit", formatItemNg: "formatItem", resizingColumnNg: "resizingColumn", resizedColumnNg: "resizedColumn", autoSizingColumnNg: "autoSizingColumn", autoSizedColumnNg: "autoSizedColumn", draggingColumnNg: "draggingColumn", draggingColumnOverNg: "draggingColumnOver", draggedColumnNg: "draggedColumn", sortingColumnNg: "sortingColumn", sortedColumnNg: "sortedColumn", pinningColumnNg: "pinningColumn", pinnedColumnNg: "pinnedColumn", resizingRowNg: "resizingRow", resizedRowNg: "resizedRow", autoSizingRowNg: "autoSizingRow", autoSizedRowNg: "autoSizedRow", draggingRowNg: "draggingRow", draggingRowOverNg: "draggingRowOver", draggedRowNg: "draggedRow", deletingRowNg: "deletingRow", deletedRowNg: "deletedRow", loadingRowsNg: "loadingRows", loadedRowsNg: "loadedRows", rowEditStartingNg: "rowEditStarting", rowEditStartedNg: "rowEditStarted", rowEditEndingNg: "rowEditEnding", rowEditEndedNg: "rowEditEnded", rowAddedNg: "rowAdded", groupCollapsedChangingNg: "groupCollapsedChanging", groupCollapsedChangedNg: "groupCollapsedChanged", columnGroupCollapsedChangingNg: "columnGroupCollapsedChanging", columnGroupCollapsedChangedNg: "columnGroupCollapsedChanged", itemsSourceChangingNg: "itemsSourceChanging", itemsSourceChangedNg: "itemsSourceChanged", selectionChangingNg: "selectionChanging", selectionChangedNg: "selectionChanged", scrollPositionChangedNg: "scrollPositionChanged", updatingViewNg: "updatingView", updatedViewNg: "updatedView", updatingLayoutNg: "updatingLayout", updatedLayoutNg: "updatedLayout", pastingNg: "pasting", pastedNg: "pasted", pastingCellNg: "pastingCell", pastedCellNg: "pastedCell", copyingNg: "copying", copiedNg: "copied" }, features: [ɵngcc0.ɵɵProvidersFeature([{ provide: "WjComponent", useExisting: forwardRef(() => WjFlexGrid_1) }, ...wjFlexGridMeta.providers]), ɵngcc0.ɵɵInheritDefinitionFeature], ngContentSelectors: _c0, decls: 2, vars: 0, template: function WjFlexGrid_Template(rf, ctx) { if (rf & 1) {
        ɵngcc0.ɵɵprojectionDef();
        ɵngcc0.ɵɵelementStart(0, "div");
        ɵngcc0.ɵɵprojection(1);
        ɵngcc0.ɵɵelementEnd();
    } }, encapsulation: 2 });WjFlexGrid.meta={outputs:wjFlexGridMeta.outputs};WjFlexGrid=WjFlexGrid_1=__decorate([__param(0,Inject(ElementRef)),__param(1,Inject(Injector)),__param(2,Inject("WjComponent")),__param(2,SkipSelf()),__param(2,Optional()),__param(3,Inject(ChangeDetectorRef))],WjFlexGrid);export{WjFlexGrid};var wjFlexGridColumnMeta={selector:"wj-flex-grid-column",standalone: false,template:"<div><ng-content></ng-content></div>",inputs:["asyncBindings","wjProperty","name","dataMap","dataType","binding","sortMemberPath","format","cellTemplate","header","width","maxLength","minWidth","maxWidth","align","allowDragging","allowSorting","allowResizing","allowMerging","aggregate","isReadOnly","cssClass","cssClassAll","isContentHtml","isSelected","visible","wordWrap","multiLine","mask","inputType","isRequired","showDropDown","dataMapEditor","dropDownCssClass","quickAutoSize","editor","placeholder","sortOrder"],outputs:["initialized","isSelectedChangePC: isSelectedChange"],providers:[]};export{wjFlexGridColumnMeta};let WjFlexGridColumn=WjFlexGridColumn_1=class WjFlexGridColumn extends wjcGrid.Column{constructor(e,t,i,o){super();this.cdRef=o;this.isInitialized=!1;this.wjProperty="columns";let r=(this._wjBehaviour=WjDirectiveBehavior.attach(this,e,t,i)).parentBehavior.directive;if(r.autoGenerateColumns){r.autoGenerateColumns=!1;r.columns.clear()}this.created()}created(){}ngOnInit(){this._wjBehaviour.ngOnInit()}ngAfterViewInit(){this._wjBehaviour.ngAfterViewInit()}ngOnDestroy(){this._wjBehaviour.ngOnDestroy()}};
WjFlexGridColumn.ɵfac = function WjFlexGridColumn_Factory(t) { return new (t || WjFlexGridColumn)(ɵngcc0.ɵɵdirectiveInject(ElementRef), ɵngcc0.ɵɵdirectiveInject(Injector), ɵngcc0.ɵɵdirectiveInject("WjComponent", 12), ɵngcc0.ɵɵdirectiveInject(ChangeDetectorRef)); };
WjFlexGridColumn.ɵcmp = /*@__PURE__*/ ɵngcc0.ɵɵdefineComponent({ type: WjFlexGridColumn, standalone: false, selectors: [["wj-flex-grid-column"]], inputs: { asyncBindings: "asyncBindings", wjProperty: "wjProperty", name: "name", dataMap: "dataMap", dataType: "dataType", binding: "binding", sortMemberPath: "sortMemberPath", format: "format", cellTemplate: "cellTemplate", header: "header", width: "width", maxLength: "maxLength", minWidth: "minWidth", maxWidth: "maxWidth", align: "align", allowDragging: "allowDragging", allowSorting: "allowSorting", allowResizing: "allowResizing", allowMerging: "allowMerging", aggregate: "aggregate", isReadOnly: "isReadOnly", cssClass: "cssClass", cssClassAll: "cssClassAll", isContentHtml: "isContentHtml", isSelected: "isSelected", visible: "visible", wordWrap: "wordWrap", multiLine: "multiLine", mask: "mask", inputType: "inputType", isRequired: "isRequired", showDropDown: "showDropDown", dataMapEditor: "dataMapEditor", dropDownCssClass: "dropDownCssClass", quickAutoSize: "quickAutoSize", editor: "editor", placeholder: "placeholder", sortOrder: "sortOrder" }, outputs: { initialized: "initialized", isSelectedChangePC: "isSelectedChange" }, features: [ɵngcc0.ɵɵProvidersFeature([{ provide: "WjComponent", useExisting: forwardRef(() => WjFlexGridColumn_1) }, ...wjFlexGridColumnMeta.providers]), ɵngcc0.ɵɵInheritDefinitionFeature], ngContentSelectors: _c0, decls: 2, vars: 0, template: function WjFlexGridColumn_Template(rf, ctx) { if (rf & 1) {
        ɵngcc0.ɵɵprojectionDef();
        ɵngcc0.ɵɵelementStart(0, "div");
        ɵngcc0.ɵɵprojection(1);
        ɵngcc0.ɵɵelementEnd();
    } }, encapsulation: 2 });WjFlexGridColumn.meta={outputs:wjFlexGridColumnMeta.outputs,changeEvents:{"grid.selectionChanged":["isSelected"]}};WjFlexGridColumn=WjFlexGridColumn_1=__decorate([__param(0,Inject(ElementRef)),__param(1,Inject(Injector)),__param(2,Inject("WjComponent")),__param(2,SkipSelf()),__param(2,Optional()),__param(3,Inject(ChangeDetectorRef))],WjFlexGridColumn);export{WjFlexGridColumn};var wjFlexGridColumnGroupMeta={selector:"wj-flex-grid-column-group",standalone: false,template:"<div><ng-content></ng-content></div>",inputs:["asyncBindings","wjProperty","name","dataMap","dataType","binding","sortMemberPath","format","cellTemplate","header","width","maxLength","minWidth","maxWidth","align","allowDragging","allowSorting","allowResizing","allowMerging","aggregate","isReadOnly","cssClass","cssClassAll","isContentHtml","isSelected","visible","wordWrap","multiLine","mask","inputType","isRequired","showDropDown","dataMapEditor","dropDownCssClass","quickAutoSize","editor","placeholder","collapseTo","isCollapsed","height","sortOrder"],outputs:["initialized","isSelectedChangePC: isSelectedChange"],providers:[]};export{wjFlexGridColumnGroupMeta};let WjFlexGridColumnGroup=WjFlexGridColumnGroup_1=class WjFlexGridColumnGroup extends wjcGrid.ColumnGroup{constructor(e,t,i){super();this.isInitialized=!1;this.wjProperty="columnGroups";this._wjBehaviour=WjDirectiveBehavior.attach(this,e,t,i);this.created()}created(){}ngOnInit(){this._wjBehaviour.ngOnInit()}ngAfterViewInit(){this._wjBehaviour.ngAfterViewInit()}ngOnDestroy(){this._wjBehaviour.ngOnDestroy()}};
WjFlexGridColumnGroup.ɵfac = function WjFlexGridColumnGroup_Factory(t) { return new (t || WjFlexGridColumnGroup)(ɵngcc0.ɵɵdirectiveInject(ElementRef), ɵngcc0.ɵɵdirectiveInject(Injector), ɵngcc0.ɵɵdirectiveInject("WjComponent", 12)); };
WjFlexGridColumnGroup.ɵcmp = /*@__PURE__*/ ɵngcc0.ɵɵdefineComponent({ type: WjFlexGridColumnGroup, standalone: false, selectors: [["wj-flex-grid-column-group"]], inputs: { asyncBindings: "asyncBindings", wjProperty: "wjProperty", name: "name", dataMap: "dataMap", dataType: "dataType", binding: "binding", sortMemberPath: "sortMemberPath", format: "format", cellTemplate: "cellTemplate", header: "header", width: "width", maxLength: "maxLength", minWidth: "minWidth", maxWidth: "maxWidth", align: "align", allowDragging: "allowDragging", allowSorting: "allowSorting", allowResizing: "allowResizing", allowMerging: "allowMerging", aggregate: "aggregate", isReadOnly: "isReadOnly", cssClass: "cssClass", cssClassAll: "cssClassAll", isContentHtml: "isContentHtml", isSelected: "isSelected", visible: "visible", wordWrap: "wordWrap", multiLine: "multiLine", mask: "mask", inputType: "inputType", isRequired: "isRequired", showDropDown: "showDropDown", dataMapEditor: "dataMapEditor", dropDownCssClass: "dropDownCssClass", quickAutoSize: "quickAutoSize", editor: "editor", placeholder: "placeholder", collapseTo: "collapseTo", isCollapsed: "isCollapsed", height: "height", sortOrder: "sortOrder" }, outputs: { initialized: "initialized", isSelectedChangePC: "isSelectedChange" }, features: [ɵngcc0.ɵɵProvidersFeature([{ provide: "WjComponent", useExisting: forwardRef(() => WjFlexGridColumnGroup_1) }, ...wjFlexGridColumnGroupMeta.providers]), ɵngcc0.ɵɵInheritDefinitionFeature], ngContentSelectors: _c0, decls: 2, vars: 0, template: function WjFlexGridColumnGroup_Template(rf, ctx) { if (rf & 1) {
        ɵngcc0.ɵɵprojectionDef();
        ɵngcc0.ɵɵelementStart(0, "div");
        ɵngcc0.ɵɵprojection(1);
        ɵngcc0.ɵɵelementEnd();
    } }, encapsulation: 2 });WjFlexGridColumnGroup.meta={outputs:wjFlexGridColumnGroupMeta.outputs,changeEvents:{"grid.selectionChanged":["isSelected"]}};WjFlexGridColumnGroup=WjFlexGridColumnGroup_1=__decorate([__param(0,Inject(ElementRef)),__param(1,Inject(Injector)),__param(2,Inject("WjComponent")),__param(2,SkipSelf()),__param(2,Optional())],WjFlexGridColumnGroup);export{WjFlexGridColumnGroup};let WjFlexGridCellTemplate=WjFlexGridCellTemplate_1=class WjFlexGridCellTemplate{constructor(e,t,i,o,r,l){this.viewContainerRef=e;this.templateRef=t;this.elRef=i;this.cdRef=l;this.autoSizeRows=!0;this.forceFullEdit=!0;if(o instanceof wjcGrid.FlexGrid)this.grid=o;else if(o instanceof wjcGrid.Column){this.column=o;let e,t=WjDirectiveBehavior.getBehavior(o);do{e=(t=t.parentBehavior)&&t.directive}while(e&&!(e instanceof wjcGrid.FlexGrid));this.grid=e}}set cellType(e){this.cellTypeStr=wjcCore.asEnum(e,CellTemplateType)}get cellType(){return this.cellTypeStr}ngOnInit(){this.ownerControl=this.column&&this.column.grid===this.grid?this.column:this.grid;this._attachToControl()}ngOnDestroy(){if(CellTemplateType[this.cellType]){this.viewContainerRef.clear();this.ownerControl[DirectiveCellFactory.getTemplContextProp(this.cellTypeStr)]=null;this.grid.invalidate()}}_instantiateTemplate(e,t){return WjDirectiveBehavior.instantiateTemplate(e,this.viewContainerRef,this.templateRef,!1,t)}_attachToControl(){if(!CellTemplateType[this.cellType])return;let e=this.cellTypeStr,t=this.ownerControl;t[DirectiveCellFactory.getTemplContextProp(e)]=this;t instanceof wjcGrid.Column&&(e===CellTemplateType.Cell||e===CellTemplateType.ColumnHeader||e===CellTemplateType.ColumnFooter)&&t._setFlag(wjcGrid.RowColFlags.HasTemplate,!0);this.grid.invalidate()}};
WjFlexGridCellTemplate.ɵfac = function WjFlexGridCellTemplate_Factory(t) { return new (t || WjFlexGridCellTemplate)(ɵngcc0.ɵɵdirectiveInject(ViewContainerRef), ɵngcc0.ɵɵdirectiveInject(TemplateRef, 8), ɵngcc0.ɵɵdirectiveInject(ElementRef), ɵngcc0.ɵɵdirectiveInject("WjComponent", 12), ɵngcc0.ɵɵdirectiveInject(Injector), ɵngcc0.ɵɵdirectiveInject(ChangeDetectorRef)); };
WjFlexGridCellTemplate.ɵdir = /*@__PURE__*/ ɵngcc0.ɵɵdefineDirective({ type: WjFlexGridCellTemplate, standalone: false, selectors: [["", "wjFlexGridCellTemplate", ""]], inputs: { wjFlexGridCellTemplate: "wjFlexGridCellTemplate", cellOverflow: "cellOverflow", valuePaths: "valuePaths", autoSizeRows: "autoSizeRows", forceFullEdit: "forceFullEdit", cellType: "cellType" }, exportAs: ["wjFlexGridCellTemplate"], features: [ɵngcc0.ɵɵProvidersFeature([{ provide: "WjComponent", useExisting: forwardRef(() => WjFlexGridCellTemplate_1) }])] });__decorate([Input()],WjFlexGridCellTemplate.prototype,"cellType",null);WjFlexGridCellTemplate=WjFlexGridCellTemplate_1=__decorate([__param(0,Inject(ViewContainerRef)),__param(1,Inject(TemplateRef)),__param(1,Optional()),__param(2,Inject(ElementRef)),__param(3,Inject("WjComponent")),__param(3,SkipSelf()),__param(3,Optional()),__param(4,Inject(Injector)),__param(5,Inject(ChangeDetectorRef))],WjFlexGridCellTemplate);export{WjFlexGridCellTemplate};export class DirectiveCellFactory extends DirectiveCellFactoryBase{constructor(e,t){super(e);this._needsCdCheck=!1;this._gridCdRef=t;e.updatedView.addHandler(()=>{if(this._needsCdCheck){this._needsCdCheck=!1;this._gridCdRef.markForCheck()}},this)}_updatedViewHandler(){setTimeout(()=>{this._autoSizeIfRequired()})}shouldInstantiate(e){let t=e.templateCache;return null==t||t.column!==e.column||!t.viewRef||t.templateContextProperty!==e.templateContextProperty||e.cell.firstChild!=t.rootElement}renderTemplate(e,t){let i=e.row,o=t?{}:e.templateCache.viewRef.context,r=e.templateContext;e.cellBindingsData=this.setBindingsData(o,i,e.column,i.dataItem,e.cellValue,r.valuePaths);e.cellBindingsData.localVars.valueFormatted=e.cellValueFormatted;if(t){let t=e.cell,i=r._instantiateTemplate(t,o),l=e.templateCache={column:e.column,viewRef:i.viewRef,rootElement:i.rootElement,templateContextProperty:e.templateContextProperty};t[e.templateContextProperty]=l}}setBindingsData(e,t,i,o,r,l){this._needsCdCheck=!0;return super.setBindingsData(e,t,i,o,r,l)}disposeTemplate(e,t,i){if(t&&t.viewRef){if(i){let e=i.viewContainerRef.indexOf(t.viewRef);e>-1&&i.viewContainerRef.remove(e)}t.viewRef=null;super.disposeTemplate(e,t,i)}}clearCell(e){e.textContent=""}applyImmediately(e){e.templateContext.cdRef.detectChanges()}flushPendingEvents(e){if(e){let t=WjDirectiveBehavior.getBehavior(e);t&&t.flushPendingEvents()}}getEditorFocusFlag(){return this.grid._edtFocus}setEditorFocusFlag(e){this.grid._edtFocus=e}checkHeight(e){WjDirectiveBehavior.getZone(this.grid).runOutsideAngular(()=>{super.checkHeight(e)})}}let moduleExports=[WjFlexGrid,WjFlexGridColumn,WjFlexGridColumnGroup,WjFlexGridCellTemplate],WjGridModule=class WjGridModule{};
WjGridModule.ɵfac = function WjGridModule_Factory(t) { return new (t || WjGridModule)(); };
WjGridModule.ɵmod = /*@__PURE__*/ ɵngcc0.ɵɵdefineNgModule({ type: WjGridModule });
WjGridModule.ɵinj = /*@__PURE__*/ ɵngcc0.ɵɵdefineInjector({ imports: [CommonModule] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && ɵngcc0.ɵsetClassMetadata(WjFlexGrid, [{
        type: Component,
        args: [{ selector: wjFlexGridMeta.selector,  standalone: false,template: wjFlexGridMeta.template, inputs: wjFlexGridMeta.inputs, outputs: wjFlexGridMeta.outputs, providers: [{ provide: "WjComponent", useExisting: forwardRef(() => WjFlexGrid_1) }, ...wjFlexGridMeta.providers] }]
    }], function () { return [{ type: undefined, decorators: [{
                type: Inject,
                args: [ElementRef]
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: [Injector]
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: ["WjComponent"]
            }, {
                type: SkipSelf
            }, {
                type: Optional
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: [ChangeDetectorRef]
            }] }]; }, null); })();
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && ɵngcc0.ɵsetClassMetadata(WjFlexGridColumn, [{
        type: Component,
        args: [{ selector: wjFlexGridColumnMeta.selector,  standalone: false,template: wjFlexGridColumnMeta.template, inputs: wjFlexGridColumnMeta.inputs, outputs: wjFlexGridColumnMeta.outputs, providers: [{ provide: "WjComponent", useExisting: forwardRef(() => WjFlexGridColumn_1) }, ...wjFlexGridColumnMeta.providers] }]
    }], function () { return [{ type: undefined, decorators: [{
                type: Inject,
                args: [ElementRef]
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: [Injector]
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: ["WjComponent"]
            }, {
                type: SkipSelf
            }, {
                type: Optional
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: [ChangeDetectorRef]
            }] }]; }, null); })();
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && ɵngcc0.ɵsetClassMetadata(WjFlexGridColumnGroup, [{
        type: Component,
        args: [{ selector: wjFlexGridColumnGroupMeta.selector,  standalone: false,template: wjFlexGridColumnGroupMeta.template, inputs: wjFlexGridColumnGroupMeta.inputs, outputs: wjFlexGridColumnGroupMeta.outputs, providers: [{ provide: "WjComponent", useExisting: forwardRef(() => WjFlexGridColumnGroup_1) }, ...wjFlexGridColumnGroupMeta.providers] }]
    }], function () { return [{ type: undefined, decorators: [{
                type: Inject,
                args: [ElementRef]
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: [Injector]
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: ["WjComponent"]
            }, {
                type: SkipSelf
            }, {
                type: Optional
            }] }]; }, null); })();
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && ɵngcc0.ɵsetClassMetadata(WjFlexGridCellTemplate, [{
        type: Directive,
        args: [{ selector: "[wjFlexGridCellTemplate]",  standalone: false,inputs: ["wjFlexGridCellTemplate", "cellOverflow", "valuePaths", "autoSizeRows", "forceFullEdit"], exportAs: "wjFlexGridCellTemplate", providers: [{ provide: "WjComponent", useExisting: forwardRef(() => WjFlexGridCellTemplate_1) }] }]
    }], function () { return [{ type: undefined, decorators: [{
                type: Inject,
                args: [ViewContainerRef]
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: [TemplateRef]
            }, {
                type: Optional
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: [ElementRef]
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: ["WjComponent"]
            }, {
                type: SkipSelf
            }, {
                type: Optional
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: [Injector]
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: [ChangeDetectorRef]
            }] }]; }, { cellType: [{
            type: Input
        }] }); })();
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && ɵngcc0.ɵsetClassMetadata(WjGridModule, [{
        type: NgModule,
        args: [{ imports: [CommonModule], declarations: [...moduleExports], exports: [...moduleExports] }]
    }], null, null); })();
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && ɵngcc0.ɵɵsetNgModuleScope(WjGridModule, { declarations: function () { return [WjFlexGrid, WjFlexGridColumn, WjFlexGridColumnGroup, WjFlexGridCellTemplate]; }, imports: function () { return [CommonModule]; }, exports: function () { return [WjFlexGrid, WjFlexGridColumn, WjFlexGridColumnGroup, WjFlexGridCellTemplate]; } }); })();export{WjGridModule};